#!/usr/local/bin/tcsh -f
#
# $Id: clock_hist_daily.tcsh,v 1.3 2006/11/04 14:40:48 ruben Exp $
#

set TTROOT="/ncc/ttpro";
set TTLIST=`$TTROOT/bin/ttconfig -v TTLIST`

set datadir=/ncc/ttfs2/henk/data_processed
limit datasize      unlimited
limit stacksize     unlimited
limit memoryuse     unlimited
limit memorylocked  unlimited
setenv PGPLOT_FONT /usr/local/lib/grfont.dat

echo -n "********************** ";date
foreach f ( $TTLIST )
   /home/ttraffic/bin/clock_hist.pl $f /gif Y
end

echo -n "********************** ";date

cd /ncc/WWW2/www_site/pub/test-traffic/Plots/

foreach f (tt??/sat*gif)
  echo "Doing mini gif $f"
  set filename = `basename $f`
  set filedir  = `dirname $f`
  /usr/local/bin/gifrsize -s .25 $f > $filedir/mini/$filename
end

echo -n "********************** ";date
