
#include "common.h"


/* $Id: querydb.h,v 1.4 2009/10/11 21:10:43 ruben Exp $ */

int route_from_routeid (MYSQL *mysql, unsigned int routeid, unsigned int src, char* route, unsigned int* len);
int routeid_from_route (MYSQL *mysql, char* route, unsigned int* routeid, unsigned int src, unsigned int* len);
int get_routes_by_time (MYSQL *mysql, unsigned int sourceID, unsigned int targetID, time_t t_start, time_t t_end, struct datastruct **d);
void reset_data(GHashTable* Data);
int match_vector(GHashTable* Data, unsigned int targetID, time_t timestamp, unsigned int *routeID, unsigned int *Nhops);
GHashTable* build_data (MYSQL *mysql, unsigned int src, time_t tstart);
int match_vector_sql(MYSQL *mysql, unsigned int sourceID, unsigned int targetID, time_t timestamp, unsigned int *routeID, unsigned int *Nhops);

gboolean remove_item (gpointer key,gpointer value,gpointer user_data);
void print_data (gpointer key,gpointer value,gpointer user_data);
void display_routes (struct datastruct *d);
