// Module header
//
// ipdvplots - create all ipdvplots + html for given time period

#include <iostream>

// XXX not needed here...
// #include <TROOT.h>
// #include <TApplication.h>

using namespace std;

#include "utils.h"
#include "TestBoxConfig.h"
#include "TTMSummaryChain.h"
#include "TTMOptions.h"

RCSID("$Id: ipdvplots.C,v 1.8 2006/11/13 15:21:28 ruben Exp $");


int main (int argc, char** argv) {

	// get options XXX should use TTMOptions and should have the ipdv.C code

	// reasanably safe static limits

	char commandline[1024];
	char timeperiod[64];

	
	// get the period argument directly from argv[] list
	// (ugly hack, but easier than remaking timestructs etc.)

	for (int argno=0; argno<argc; argno++) {
		if (strcmp(argv[argno], "-p") == 0) {
			strcpy(timeperiod, argv[argno+1]);
			break;
		}
	}

	TTMOptions options(argc, argv, "46dp:o:");
	TestBoxConfig config(options);

// now we can start ...
	
	// Keep it a reference, so we won't invoke the assignment operator
        map<uint,TestBox*> &tblist = config.GetTBList(); 

	for (map<uint,TestBox*>::iterator i=tblist.begin() ; i != tblist.end(); i++) {
		sprintf(commandline, "ipdv -s %d -o %s -H -f gif -p %s -%d%s",
			PAIR_VAL(i)->GetId(), options.OutputPath().c_str(),
			timeperiod, options.IPversion(), options.Debug() ? " -d" : "");
		system(commandline);
	}
	return(0);
}
