#!/bin/sh
#
# $Id: fixPlots.sh,v 1.4 2006/11/04 14:49:59 ruben Exp $
#
# shell script for the TTwwwpages project
#
# Author:       Fotis Georgatos, RIPE NCC (1999)

TTROOT=/ncc/ttpro
PLOTSDIR="$TTROOT/data/plots"
TTLIST=`$TTROOT/bin/ttconfig -v TTLIST|xargs`
LOGOFILE="$TTROOT/wwwpages/logo_big.gif"
LOGOFILESMALL="$TTROOT/wwwpages/logo_small.gif"

for i in $TTLIST; do
  CURPATH=$PLOTSDIR/$i;

  echo $i
  mkdir -p $CURPATH/mini >/dev/null 2>&1

  if [ ! -f $CURPATH/satellites.$i.gif ]; then
    cp $LOGOFILE $CURPATH/satellites.$i.gif
    cp $LOGOFILESMALL $CURPATH/mini/satellites.$i.gif
    echo $CURPATH/satellites.$i.gif was just added;
  fi

  for j in $TTLIST; do
    if [ $i = $j ] ; then continue; fi;
    #echo $i $j

    for curfile in \
      day.$i.$j.gif \
      week.$i.$j.gif \
      month.$i.$j.gif ; do
    if [ ! -f $CURPATH/$curfile ] ; then
	cp $LOGOFILE $CURPATH/$curfile
	cp $LOGOFILESMALL $CURPATH/mini/$curfile
	echo $CURPATH/$curfile has been just added
    fi
    done
  done

done

exit 0
