/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
 * ----------------------------------------------------------------------------
 * $Id: internal.h,v 1.2 2005/01/26 15:28:53 tom Exp $
 *
 * This file contains internal stuff.
 */

#include "ntpns.h"

/* init functions */
void init_config(evContext ctx);
void init_load(evContext ctx);
void init_log(evContext ctx);
void init_pll(evContext ctx);
void init_pllmath(evContext ctx);
void init_record(evContext ctx);
void init_source(evContext ctx);
void init_shmem(evContext ctx);
void run_shmem(evContext ctx);
void init_telnet(evContext ctx);
void init_watch(evContext ctx);
void init_watch(evContext ctx);

/* States of the source selection */
typedef enum {
	NOSRC		= 1,
	FRAC_SWITCH	= 2,
	FRAC_TRACK	= 3,
	UTC_STEP	= 4,
	SRC_SWITCH	= 5,
	UTC_LOCK	= 6,
	COAST		= 7,
	FRAC_LOCK	= 8
} clk_state_e;

extern clk_state_e clk_state;
struct source;
extern struct source *selsrc;

void log_close(int fd);
