#ifdef HAVE_CONFIG_H
#include <gvconfig.h>
#endif

#include <stdio.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <agraph.h>

#ifndef HAVE_GETOPT_DECL
#include <getopt.h>
#endif

#define INF ((unsigned int)-1)


int main( int argc, char *argv[]) {
   Agraph_t *g;
   FILE *graph;
   int i;

   if( argc >= 2 ) {
      graph = fopen( argv[1], "r" );
      if( graph != NULL ) {
         g = agread( graph, 0 );
         fclose(graph);
      }
   }

   if( argc > 2 ) {
      for( i = 2; i < argc; i++ ) {
         graph = fopen( argv[i], "r" );
         if( graph != NULL ) {
            g = agconcat( g, graph, 0 );
            fclose(graph);
         }
      }
   }

   agwrite( g, stdout );

   return 0;
}
