#!/usr/local/bin/perl5 -w

#
# This script creates the cgi-bin code in 3 steps:
#
# print_header()         Print out everything that starts the page
# list_of_active_boxes() Create list of boxes (and other variable output)
# print_footer()         Print out bottom of the page
#


use Socket;

#
# Maximum number of boxes that we have
#
$MAXBOXES = 100;
$OUTFILE  = "/data/apache/htdocs/cgi-bin/inbound_delays.cgi";

open (OUTFILE, ">$OUTFILE") || die "Cannot open output file";

print_header ();
list_of_active_boxes ();
print_footer ();

exit;

sub print_header {
#
# Prints the HTML for the top of the page
#
print OUTFILE <<EOF
#!/usr/local/rrd/bin/rrdcgi 

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-1">
<TITLE>Inbound Delays</TITLE>
<SCRIPT>
<!--
function F_loadRollover(){} function F_roll(){}
//-->
</SCRIPT>
<SCRIPT LANGUAGE="JavaScript1.2" SRC="../rollover.js"></SCRIPT>
</HEAD>
<BODY BGCOLOR="#FFFFF8" TEXT="#000000" LINK="#333300" VLINK="#6699CC" ALINK="#000000" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
  <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=724 NOF=LY>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD WIDTH=24 HEIGHT=7><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=24 HEIGHT=1 BORDER=0></TD>
      <TD></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD HEIGHT=30></TD>
      <TD WIDTH=700><IMG ID="Banner1" HEIGHT=30 WIDTH=700 SRC="../assets/images/autogen/Inbound_Delays_NBanner.GIF" BORDER=0 ALT="Inbound Delays"></TD>
    </TR>
  </TABLE>
  <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=524 NOF=LY>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD WIDTH=24 HEIGHT=7><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=24 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=1><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=1 HEIGHT=1 BORDER=0></TD>
      <TD></TD>
      <TD WIDTH=399><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=399 HEIGHT=1 BORDER=0></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD HEIGHT=20></TD>
      <TD COLSPAN=3 WIDTH=500>
        <TABLE ID="NavigationBar1" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=NB_FYHP WIDTH=500>
          <TR VALIGN=TOP ALIGN=LEFT>
            <TD WIDTH=100><A HREF="../html/documentation.html" onMouseOver="F_roll('NavigationButton2',1)" onMouseOut="F_roll('NavigationButton2',0)"><IMG ID="NavigationButton2" NAME="NavigationButton2" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_8.GIF" onLoad="F_loadRollover(this,'_NRp2_10.GIF')" BORDER=0 ALT="Documentation"></A></TD>
            <TD WIDTH=100><A HREF="../html/status.html" onMouseOver="F_roll('NavigationButton3',1)" onMouseOut="F_roll('NavigationButton3',0)"><IMG ID="NavigationButton3" NAME="NavigationButton3" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_9.GIF" onLoad="F_loadRollover(this,'_NRp2_11.GIF')" BORDER=0 ALT="Status"></A></TD>
            <TD WIDTH=100><A HREF="../html/configuration.html" onMouseOver="F_roll('NavigationButton4',1)" onMouseOut="F_roll('NavigationButton4',0)"><IMG ID="NavigationButton4" NAME="NavigationButton4" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_10.GIF" onLoad="F_loadRollover(this,'_NRp2_12.GIF')" BORDER=0 ALT="Configuration"></A></TD>
            <TD WIDTH=100><A HREF="../html/measurements.html" onMouseOver="F_roll('NavigationButton5',1)" onMouseOut="F_roll('NavigationButton5',0)"><IMG ID="NavigationButton5" NAME="NavigationButton5" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_11.GIF" onLoad="F_loadRollover(this,'_NRp2_13.GIF')" BORDER=0 ALT="Measurements"></A></TD>
            <TD WIDTH=100 HEIGHT=20><A HREF="http://www.ripe.net/test-traffic" onMouseOver="F_roll('NavigationButton6',1)" onMouseOut="F_roll('NavigationButton6',0)"><IMG ID="NavigationButton6" NAME="NavigationButton6" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_12.GIF" onLoad="F_loadRollover(this,'_NRp2_14.GIF')" BORDER=0 ALT="TTM Web Site"></A></TD>
          </TR>
        </TABLE>
      </TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD COLSPAN=4 HEIGHT=11></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD COLSPAN=2 HEIGHT=20></TD>
      <TD WIDTH=100>
        <TABLE ID="NavigationBar3" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=NB_CNHP WIDTH=100>
          <TR VALIGN=TOP ALIGN=LEFT>
            <TD WIDTH=100 HEIGHT=20><A HREF="../html/delays_help.html" onMouseOver="F_roll('NavigationButton1',1)" onMouseOut="F_roll('NavigationButton1',0)"><IMG ID="NavigationButton1" NAME="NavigationButton1" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/Delays_Help_Np1.GIF" onLoad="F_loadRollover(this,'Delays_Help_NRp2.GIF')" BORDER=0 ALT="Delays Help"></A></TD>
          </TR>
        </TABLE>
      </TD>
      <TD></TD>
    </TR>
  </TABLE>
  <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=725 NOF=LY>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD WIDTH=25 HEIGHT=14><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=25 HEIGHT=1 BORDER=0></TD>
      <TD></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD HEIGHT=4></TD>
      <TD ALIGN=LEFT VALIGN=TOP WIDTH=700><IMG ID="SiteStyleLine9" HEIGHT=4 WIDTH=700 SRC="../assets/images/Line.gif" BORDER=0></TD>
    </TR>
  </TABLE>
  <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=LY>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD WIDTH=24 HEIGHT=12><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=24 HEIGHT=1 BORDER=0></TD>
      <TD></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD></TD>
      <TD WIDTH=625>
        <FORM NAME="Inbound delays" ACTION="/cgi-bin/inbound_delays.cgi" METHOD=GET>
          <TABLE ID="Table1" BORDER=0 CELLSPACING=5 CELLPADDING=0 WIDTH=625>
            <TR>
             <TD COLSPAN=2>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Select Test-box:</B>
<SELECT ID="TB List" NAME="RRD_NAME">
EOF

}

sub list_of_active_boxes {
  # 
  # Creates a list of all TB that have sent data to this box in the 
  # last week.  
  #
  for ($i=1 ; $i<$MAXBOXES ; $i++) {
    if   ($i <   10) { $tb = "tt0".$i; }
    else             { $tb = "tt".$i;} 

    $hostname = inet_aton($tb);
    if (defined $hostname) { 
      $tbip = inet_ntoa ($hostname);
      $rrdfile = "/data/rrd/".$tbip.".rrd";
      if ((-e $rrdfile) && ((-M $rrdfile) < 8.0)) {
        print OUTFILE "<OPTION VALUE=\"$tbip\">$tb</OPTION>\n";
      }
    }
  }
}

sub print_footer {
# 
# Print HTML for the bottom of the page
#

print OUTFILE <<EOF
</SELECT></FONT>
</TD>
            </TR>

              <TD WIDTH=76 HEIGHT=27>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Start:</B></FONT><B></B></P>
              </TD>
              <TD WIDTH=132>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"></FONT>
                  <TABLE WIDTH="100%" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=TE>
                    <TR>
                      <TD ALIGN="LEFT"><INPUT ID="Forms Edit Field1" TYPE=TEXT NAME="RRD_START" VALUE="now-4h" SIZE=16 MAXLENGTH=40></TD>
                    </TR>
                  </TABLE>
                  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"></FONT></TD>
              <TD WIDTH=86>
                <P ALIGN=RIGHT><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Length: </B></FONT><B></B></P>
              </TD>
              <TD WIDTH=131>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"></FONT>
                  <TABLE WIDTH="100%" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=TE>
                    <TR>
                      <TD ALIGN="LEFT">
                        <SELECT ID="FormsComboBox4" NAME="RRD_END">
                          <OPTION VALUE="-estart+1week">1 week</OPTION>
                          <OPTION VALUE="-estart+4days">4 days</OPTION>
                          <OPTION VALUE="-estart+2days">2 days</OPTION>
                          <OPTION VALUE="-estart+1day">1 day</OPTION>
                          <OPTION VALUE="-estart+12h">12 hours</OPTION>
                          <OPTION VALUE="-estart+6h">6 hours</OPTION>
                          <OPTION VALUE="-estart+4h" SELECTED>4 hours</OPTION>
                          <OPTION VALUE="-estart+2h">2 hours</OPTION>
                          <OPTION VALUE="-estart+1h">1 hour</OPTION>
                          <OPTION VALUE="-estart+1800s">30 minutes</OPTION>
                          <OPTION VALUE="-estart+900s">15 minutes</OPTION>
                        </SELECT>
                      </TD>
                    </TR>
                  </TABLE>
                  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"></FONT></TD>
              <TD WIDTH=170>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">&nbsp;</FONT></P>
              </TD>
            </TR>
            <TR>
              <TD WIDTH=76>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Height:</B></FONT><B></B></P>
              </TD>
              <TD WIDTH=132>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
                  <SELECT ID="FormsComboBox3" NAME="RRD_W">
                    <OPTION VALUE="-h100">swall</OPTION>
                    <OPTION VALUE="-h200" SELECTED>medium</OPTION>
                    <OPTION VALUE="-h300">high</OPTION>
                  </SELECT>
                  </FONT></TD>
              <TD WIDTH=86>
                <P ALIGN=RIGHT><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Width: </B></FONT><B></B></P>
              </TD>
              <TD WIDTH=131>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
                  <SELECT ID="FormsComboBox5" NAME="RRD_H">
                    <OPTION VALUE="-w400">narrow</OPTION>
                    <OPTION VALUE="-w600" SELECTED>medium</OPTION>
                    <OPTION VALUE="-w800">wide</OPTION>
                  </SELECT>
                  </FONT></TD>
              <TD>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">&nbsp;</FONT></P>
              </TD>
            </TR>
            <TR>
              <TD WIDTH=76>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Y-range: </B></FONT><B></B></P>
              </TD>
              <TD WIDTH=132>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"></FONT>
                  <TABLE WIDTH="100%" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=TE>
                    <TR>
                      <TD ALIGN="LEFT"><INPUT ID="RRD_L" TYPE=TEXT NAME="RRD_L" VALUE="0" SIZE=16 MAXLENGTH=40></TD>
                    </TR>
                  </TABLE>
                  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"></FONT></TD>
              <TD WIDTH=86>
                <P ALIGN=CENTER><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>:</B></FONT><B></B></P>
              </TD>
              <TD WIDTH=131>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"></FONT>
                  <TABLE WIDTH="100%" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=TE>
                    <TR>
                      <TD ALIGN="LEFT"><INPUT ID="FormsEditField3" TYPE=TEXT NAME="RRD_R" VALUE="1" SIZE=16 MAXLENGTH=40></TD>
                    </TR>
                  </TABLE>
                  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"></FONT></TD>
              <TD WIDTH=170>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
                  <SELECT ID="FormsComboBox6" NAME="RRD_RIGID">
                    <OPTION VALUE="-l0" SELECTED>auto-increment</OPTION>
                    <OPTION VALUE="--rigid">fixed</OPTION>
                  </SELECT>
                  </FONT></TD>
            </TR>
            <TR>
              <TD HEIGHT=27>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">&nbsp;</FONT></P>
              </TD>
              <TD WIDTH=132>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><INPUT TYPE=SUBMIT NAME="Draw" VALUE="Draw" ID="FormsButton3"></FONT></TD>
              <TD>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">&nbsp;</FONT></P>
              </TD>
              <TD>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">&nbsp;</FONT></P>
              </TD>
              <TD>
                <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">&nbsp;</FONT></P>
              </TD>
            </TR>
          </TABLE>

<RRD::GOODFOR 5>

<RRD::GRAPH 
 /home/ttraffic/apache/htdocs/gif/<RRD::CV::PATH RRD_NAME>.<RRD::TIME::NOW "%Y%m%d%H%M%S">.gif     
 --imginfo '<IMG SRC=/gif/%s WIDTH=%lu HEIGHT=%lu >'
 --title="Incoming Delays from <RRD::CV::PATH RRD_NAME>"
 <RRD::CV::QUOTE RRD_W> 
 <RRD::CV::QUOTE RRD_H> 
 -l<RRD::CV::QUOTE RRD_L>
 -u<RRD::CV::QUOTE RRD_R>
 <RRD::CV::QUOTE RRD_RIGID>
 <RRD::CV::QUOTE RRD_END>
 -s<RRD::CV::QUOTE RRD_START>
 -v "Delay [ms]"
 -c CANVAS#E0E0E0
 DEF:val1=/data/rrd/<RRD::CV::PATH RRD_NAME>.rrd:delay:MAX
 DEF:val2=/data/rrd/<RRD::CV::PATH RRD_NAME>.rrd:delay:AVERAGE
 DEF:val3=/data/rrd/<RRD::CV::PATH RRD_NAME>.rrd:delay:MIN
 AREA:val1#FF8800:"Spread:        "
 GPRINT:val3:MIN:"%.2lf ... "
 GPRINT:val1:MAX:"%.2lf ms\\n"
 LINE2:val2#0000FF:"Average Delay:"
 AREA:val3#E0E0E0
 GPRINT:val2:AVERAGE:"%.2lf ms"
>
        </FORM>

      </TD>
    </TR>
  </TABLE>

  <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=724 NOF=LY>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD WIDTH=24><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=24 HEIGHT=1 BORDER=0></TD>
      <TD>
</TD>
</TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD HEIGHT=4></TD>
      <TD ALIGN=LEFT VALIGN=TOP WIDTH=700><BR><IMG ID="SiteStyleLine6" HEIGHT=4 WIDTH=700 SRC="../assets/images/Line.gif" BORDER=0></TD>
    </TR>
  </TABLE>
</BODY>
</HTML>
 

EOF
}
