#!/bin/sh
#
# $Id#
#

if [ "$1" = "" ]; then
	echo -e "Usage: `basename $0` <file/->\n" >&2
	exit 1
fi

while read i; do
	# Check there is no explicit route to the destination
	if netstat -rn -f inet6 | grep -q $i; then
#		echo $i SKIPPED deletion, no existing route
#		continue
#	fi
	else
		# Delete host route. As it is not in the routing table,
		# we are sure that it is a cloned route and can be deleted
		# safely
		route delete -inet6 $i > /dev/null 2> /dev/null
		#route delete -inet6 $i
	fi
	result=`/usr/local/bin/findmtu $i 2>/dev/null`
	if [ -z "$result" ]; then
		echo "$i ERROR"
	else
		echo "`perl -e 'print time'` `hostname` `grep 6SND /home/ttraffic/config/configfile | cut -f 3 -d\  | sort | uniq | xargs -n 1 host -t AAAA | grep $i | cut -d " " -f1` $result"
#		 echo "$i $result"

	fi
done
