#!/bin/sh
#
# $Id#
#

NTPDC=

if [ -x /usr/sbin/ntpdc ]; then
	NTPDC="/usr/sbin/ntpdc"
elif [ -x /usr/sbin/xntpdc ]; then
	NTPDC="/usr/sbin/xntpdc"
elif [ -x /usr/local/bin/xntpdc ]; then
	NTPDC="/usr/local/bin/xntpdc"
else
	echo "no (x)ntpdc found, exiting..."
	exit 1
fi


(
    while true; do
	date;
	${NTPDC} -c peers;
	sleep 30;
	done
) | awk 'BEGIN {NEWPEER="UNSYNCED";PEER="NONE";MESSAGE=""}
	/GMT/ {DATE=$0}
	/^\*tt/ {MESSAGE="WARNING: "}
	!/^\*tt/ {MESSAGE="INFO: "}
	/^\*/ {NEWPEER=substr($1,2);
		if (NEWPEER != PEER ) {
			MESSAGE=MESSAGE "Switching FROM " PEER " to: " NEWPEER;
			system("/usr/bin/logger \"" MESSAGE "\"")
			PEER=NEWPEER
		}
	{
		if (NEWPEER == "UNSYNCED")
		{
			system("/usr/bin/logger \"WARNING: Not synchronized to any peer now\"")
		}
	}
	}'
