#!/usr/local/bin/perl5 -w
#
# $Id#
#
#
# Comments:
# * If you change format of relationgroup.config or listoftestboxes.txt you MUST change many things in the code!!!!!
#
#
#


my @relation = ();
my $PortNumber = "";
my $StandardPacketLenght = "";
my $MaxPacketLenght = "";
my $StandardRate = "";
my $MaxRate = "";
my @aux = ();
my @imput_line = ();
my %fields = ();
my $buffer = "";
my $head = "";
my $tail = "";
my $changed = 0;
my $tb = 0;
my @city = ();
my $message = "";
my $hostname = `hostname`;
my $total_volume = 0;
my $sizerate = 0;
my $MinPacketLenght = "";
#### Read query string from browser
$buffer = $ENV{'QUERY_STRING'};


#$buffer ="tbtarget=tt08%3A+NORDUnet%2C+Stockholm%2C+SE&packetlenght=101&rate=60&action=ADD";
#$buffer = "tbtarget=tt01 - New York&packetlenght=100&rate=120&action=DEL";
$_ = $buffer;


s/%2F/\//g;
s/%2C/,/g;
s/%2B/+/g;
s/%3A/:/g;

$buffer = $_;
@input_line = split (/&/, $buffer);
foreach $entry (@input_line) {
  ($head, $tail) = split(/=/, $entry);
  $fields{$head} = $tail;
}

#### Read listofcities file 
unless(open(FP, "../assets/listofcities.txt")){
    print "Could not open file! \n";
    die;
}
my @auxhost = split(/\./,$hostname);
while(<FP>){   
    next if(/$auxhost[0]/);
    push @city, $_;
}

close(FP);

#### Read config file with state data
unless(open(FP, " /data/apache/htdocs/cgi-bin/relationgroup.config")){
#unless(open(FP, "./relationgroup.config")){
    print "Could not open file! \n";
    die;
}
while(<FP>){
    my @aux = ();
    if(($_ =~ /^\#/) &&  ($_ =~ /^\s+$/)) {
	next;
    }
    @aux = split(/\s+/,$_);
    if(/PortNumber/){
	$PortNumber = $aux[1];
	next;
    }
    if(/StandardPacketLenght/){
	$StandardPacketLenght = $aux[1];
	next;
    }
    if(/MaxPacketLenght/){
	$MaxPacketLenght = $aux[1];
	next;
    }
    if(/StandardRate/){
	$StandardRate = $aux[1];
	next;
    }
   if(/MaxRate/){
	$MaxRate = $aux[1];
	next;
    }
    if(/MinPacketLenght/){
        $MinPacketLenght = $aux[1];
	next;
    }
#to add elements to the relation group
#like trace routes, bandwidth and etc
#create a new matrix for each one of
#them. Fill the matrix using:
# *d for delays
# *bdfor bandwidth
# *trfor trace routes
    if(/^dl/){      
	push @relation , [ @aux ];
    }
}
close(FP);

@relation = sort bytb @relation;   

#### Check User input

my $ret = &Check_Userinput($fields{'packetlenght'}, $fields{'rate'});

#### Deal with User actions 
if($ret){
    $tb = &Extract_Tb($fields{'tbtarget'});
    my $ret = &Check_Existence;
    if($fields{'action'} =~ /ADD/){
        if($hostname=~/$tb/){
	    $message = "ERROR: you can't add a Measurement Relation to your own test box!";
	}else{
	    if(!$ret){    
	        @aux = ();
                @aux = ("dl_add", "BLUE", $tb, $fields{'packetlenght'},$fields{'rate'},"*"); 
	        push @relation , [@aux];
	        &Record_File;
            }else{
                $message = "ERROR: $tb $fields{'packetlenght'} $fields{'rate'} already exists. Can't duplicate Measurement Relations!"; 
	    }
	}
    }elsif($fields{'action'} =~ /DEL/){ 
	if($ret){      
	    if($relation[$ret][1] eq "BLACK"){
		$message = "ERROR: A Measurement Relation defined by TTM-Operator can not be deleted";
	    }elsif($relation[$ret][1] eq "PURPLE"){
		$message = "ERROR: A Measurement Relation defined by a remote host can not be deleted";
	    }else{
                $relation[$ret][0] = "dl_del";
	        &Record_File;
	    }
	}else{
	    $message = "ERROR: not found Measurement Relation like $tb $fields{'packetlenght'} $fields{'rate'}. Can't delete!";
	}
      
    }elsif($fields{'action'} =~ /MOD/){ #not in use
        $PortNumber = $fields{'portnumber'} if($fields{'portnumber'});   
        $PacketLenght = $fields{'maxpacklenght'} if($fields{'maxpacklenght'});
        $MaxRate = $fields{'maxrate'} if($fields{'maxrate'});
        &Record_File;
    }
}

#### HTML printing starts here
	
print "Content-Type: text/html\n\n";
	
print <<EOF;

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-1">
<TITLE>Configuration</TITLE>
<SCRIPT>
<!--
function F_loadRollover(){} function F_roll(){}
//-->
</SCRIPT>
<SCRIPT LANGUAGE="JavaScript1.2" SRC="../rollover.js"></SCRIPT>
</HEAD>
<BODY NOF="(MB=(configurelayout, 123, 50, 24, 10), L=(ConfigurationLayout, 701, 572))" BGCOLOR="#FFFFF8" TEXT="#000000" LINK="#333300" VLINK="#6699CC" ALINK="#000000" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
  <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=725 NOF=LY>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD WIDTH=24 HEIGHT=6><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=24 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=1><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=1 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=199><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=199 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=400><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=400 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=1><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=1 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=99><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=99 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=1><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=1 HEIGHT=1 BORDER=0></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD COLSPAN=2 HEIGHT=30></TD>
      <TD COLSPAN=5 WIDTH=700><IMG ID="Banner1" HEIGHT=30 WIDTH=700 SRC="../assets/images/autogen/Configuration_NBanner.GIF" BORDER=0 ALT="Configuration" NOF=B_H></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD COLSPAN=7 HEIGHT=5></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD HEIGHT=20></TD>
      <TD COLSPAN=5 WIDTH=700>
        <TABLE ID="NavigationBar1" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=NB_UYHP WIDTH=700>
          <TR VALIGN=TOP ALIGN=LEFT>
            <TD WIDTH=100><A HREF="../index.html" onMouseOver="F_roll('NavigationButton1',1)" onMouseOut="F_roll('NavigationButton1',0)"><IMG ID="NavigationButton1" NAME="NavigationButton1" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_67.GIF" onLoad="F_loadRollover(this,'_NRp2_73.GIF')" BORDER=0 ALT="Test Box Home"></A></TD>
            <TD WIDTH=100><A HREF="../html/documentation.html" onMouseOver="F_roll('NavigationButton2',1)" onMouseOut="F_roll('NavigationButton2',0)"><IMG ID="NavigationButton2" NAME="NavigationButton2" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_60.GIF" onLoad="F_loadRollover(this,'_NRp2_66.GIF')" BORDER=0 ALT="Documentation"></A></TD>
            <TD WIDTH=100><A HREF="../html/status.html" onMouseOver="F_roll('NavigationButton3',1)" onMouseOut="F_roll('NavigationButton3',0)"><IMG ID="NavigationButton3" NAME="NavigationButton3" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_62.GIF" onLoad="F_loadRollover(this,'_NRp2_68.GIF')" BORDER=0 ALT="Status"></A></TD>
            <TD WIDTH=100><A HREF="../cgi-bin/configuration_targets.cgi" onMouseOver="F_roll('NavigationButton4',1)" onMouseOut="F_roll('NavigationButton4',0)"><IMG ID="NavigationButton4" NAME="NavigationButton4" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Hp3_14.GIF" onLoad="F_loadRollover(this,'_HRp4_14.GIF')" BORDER=0 ALT="Configuration"></A></TD>
            <TD WIDTH=100><A HREF="../html/measurements.html" onMouseOver="F_roll('NavigationButton5',1)" onMouseOut="F_roll('NavigationButton5',0)"><IMG ID="NavigationButton5" NAME="NavigationButton5" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_68.GIF" onLoad="F_loadRollover(this,'_NRp2_74.GIF')" BORDER=0 ALT="Measurements"></A></TD>
            <TD WIDTH=100><A HREF="http://www.ripe.net/test-traffic" onMouseOver="F_roll('NavigationButton6',1)" onMouseOut="F_roll('NavigationButton6',0)"><IMG ID="NavigationButton6" NAME="NavigationButton6" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_66.GIF" onLoad="F_loadRollover(this,'_NRp2_72.GIF')" BORDER=0 ALT="TTM Web Site"></A></TD>
            <TD WIDTH=100 HEIGHT=20><A HREF="../html/help.html" onMouseOver="F_roll('NavigationButton7',1)" onMouseOut="F_roll('NavigationButton7',0)"><IMG ID="NavigationButton7" NAME="NavigationButton7" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_75.GIF" onLoad="F_loadRollover(this,'_NRp2_81.GIF')" BORDER=0 ALT="Help"></A></TD>
          </TR>
        </TABLE>
      </TD>
      <TD></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD COLSPAN=7 HEIGHT=13></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD HEIGHT=20></TD>
      <TD COLSPAN=2 WIDTH=200>
        <TABLE ID="NavigationBar2" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=NB_UYHP WIDTH=200>
          <TR VALIGN=TOP ALIGN=LEFT>
            <TD WIDTH=100><A HREF="../cgi-bin/configuration_targets.cgi" onMouseOver="F_roll('NavigationButton8',1)" onMouseOut="F_roll('NavigationButton8',0)"><IMG ID="NavigationButton8" NAME="NavigationButton8" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Hp3_17.GIF" onLoad="F_loadRollover(this,'_HRp4_17.GIF')" BORDER=0 ALT="Configuration"></A></TD>
            <TD WIDTH=100 HEIGHT=20><A HREF="../html/configurationhelp.html" onMouseOver="F_roll('NavigationButton9',1)" onMouseOut="F_roll('NavigationButton9',0)"><IMG ID="NavigationButton9" NAME="NavigationButton9" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_88.GIF" onLoad="F_loadRollover(this,'_NRp2_87.GIF')" BORDER=0 ALT="ConfigurationHelp"></A></TD>
          </TR>
        </TABLE>
      </TD>
      <TD COLSPAN=4></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD COLSPAN=7 HEIGHT=12></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD COLSPAN=2 HEIGHT=4></TD>
      <TD COLSPAN=3 ALIGN=LEFT VALIGN=TOP WIDTH=600><IMG ID="SiteStyleLine2" HEIGHT=4 WIDTH=600 SRC="../assets/images/Line.gif" BORDER=0></TD>
      <TD COLSPAN=2></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD COLSPAN=6 HEIGHT=13></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD></TD>
      <TD COLSPAN=3 WIDTH=605>

<TABLE BORDER=0 CELLSPACING = 10>

<TR>
<TH>Current Settings</TH>
<TH>Change Settings</TH>
</TR>

<TR>
<TD>
<TABLE BORDER=1>

<TR>
  <TD>Target
  <TD>Packet Length
  <TD>Rate
  <TD>Status

EOF

for(my $i=0; $i < scalar(@relation);$i++){
    $sizerate = $sizerate + ($relation[$i][3] * $relation[$i][4]);
    if($relation[$i][0] ne "dl_del"){
	print "<TR> \n";
	print "  <TD><FONT COLOR=$relation[$i][1]> $relation[$i][2] </FONT>\n";
	print "   <TD><FONT COLOR=$relation[$i][1]> $relation[$i][3] </FONT>\n";
	print "   <TD><FONT COLOR=$relation[$i][1]> $relation[$i][4] </FONT>\n";
	print "   <TD><FONT COLOR=$relation[$i][1]> $relation[$i][5] </FONT>\n";
    }
}
$total_volume =  $sizerate * (1/450);
print <<EOF1;
</TABLE>

</TD>

<TD VALIGN=TOP>
<TABLE BORDER=0>
 <form method="GET" action="/cgi-bin/configuration_targets.cgi" >

 <TR>
    <TD ALIGN=RIGHT>Target: </TD>
    <TD ALIGN=LEFT>
    <select label=Target name=tbtarget size=0>
EOF1
    for(my $i=0; $i < scalar(@city);$i++){
        print "<option>".$city[$i]."\n"  if($city[$i]);
    }
print <<EOF2;    
    </select>
    </TD>
 </TR>
 <TR>
 <TD ALIGN=RIGHT> Packet Lenght:</TD>
 <TD ALIGN=LEFT><input type=text name=packetlenght size=10 maxlength=10></TD>
 </TR>
 <TR>
<TD ALIGN=RIGHT> Rate:</TD>
<TD ALIGN=LEFT> <input type=text name=rate size=10 maxlength=10></TD>
 </TR>
 <TR>
<TD ALIGN=RIGHT> <input type=submit name=action VALUE="ADD"></TD>
 <TD><input type=submit name=action VALUE="DEL"></TD>
 </TR>
</form> 

</TABLE>
<FONT COLOR=RED SIZE=2>
$message
</FONT>
<FONT COLOR=BLACK SIZE=4>
<hr align=center width=100%>
Total Volume: $total_volume
</FONT>
</TD>
</TR>
</TABLE>
      </TD>
      <TD COLSPAN=2></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD HEIGHT=4></TD>
      <TD COLSPAN=5 ALIGN=LEFT VALIGN=TOP WIDTH=701><IMG ID="SiteStyleLine6" HEIGHT=4 WIDTH=701 SRC="../assets/images/Line.gif" BORDER=0></TD>
    </TR>
  </TABLE>
</BODY>
</HTML>
EOF2

sub Extract_Tb {
    my @aux = split(/:/,$_[0]);
    $_=$aux[0];
    s/\s//;
    s/\n//;
    $aux[0]=$_;
    return $aux[0];
}


sub  Record_File {
   unless(open(FP, ">/data/apache/htdocs/cgi-bin/relationgroup.config")){
#   unless(open(FP, "> ./relationgroup.config")){
	print "Could not open file! \n";
        die;
    }
   print FP "PortNumber ". $PortNumber."\n";
   print FP "StandardPacketLenght " . $StandardPacketLenght."\n";
   print FP "MaxPacketLenght " . $MaxPacketLenght."\n";
   print FP "StandardRate ". $StandardRate."\n";
   print FP "MaxRate ". $MaxRate."\n";


   
  @relation = sort bytb @relation;     

 
   for($i=0; $i < scalar(@relation);$i++){
           print FP  $relation[$i][0]." ".$relation[$i][1]." ".$relation[$i][2]." ".$relation[$i][3]." ".$relation[$i][4]." ".$relation[$i][5]."\n";      
   }
    close(FP);
} # Record_File ends here !!!


 sub bytb {

$$a[2] cmp $$b[2]

} 

sub Check_Userinput {
    $_ =  $fields{'packetlenght'};
    s/\s//;
    $fields{'packetlenght'} = $_;
    $_ =  $fields{'rate'};
    s/\s//;
    $fields{'rate'} = $_;
    if($fields{'packetlenght'} eq ""){
	$fields{'packetlenght'} = $StandardPacketLenght;
    }
    if($fields{'rate'} eq ""){
	$fields{'rate'} = $StandardRate;
    }
    unless($fields{'packetlenght'}=~/^\d+$/){
	$message = "ERROR: $fields{'packetlenght'} is not a number !";
	return 0;
    }
    unless($fields{'rate'}=~/^\d+$/){
	$message = "ERROR: $fields{'rate'} is not a number !";
	return 0;
    }
    if($fields{'packetlenght'} > $MaxPacketLenght){
	$message = "ERROR: Packet Lenght must be smaller than $MaxPacketLenght !";
	return 0;
    }
    if($fields{'rate'} > $MaxRate){
	$message = "ERROR: Rate must be smaller than $MaxRate !";
	return 0;
    }
    if($fields{'packetlenght'} < $MinPacketLenght){
	$message = "ERROR: Packet Lenght must be bigger than $MinPacketLenght !";
	return 0;
    }
    return 1;
} # Check_Userinput ends here !!!


sub Check_Existence{

    for($i=0; $i < scalar(@relation);$i++){
        if(($tb=~/$relation[$i][2]/) && ($relation[$i][3]=~/$fields{'packetlenght'}/) && ($relation[$i][4]=~/$fields{'rate'}/)){    
            #m.r. exists! 
	    $i =1 if(!$i);
            return $i;         
        }
    }
    return 0;
}

























