#!/bin/sh

WD=$1
WORLDDIR=$2
CURDIR=$3

sed -i "" -e /beastie/d ${WD}/boot/loader.rc
sed -i "" -e /ttyd0/s/off/on/ ${WD}/etc/ttys
echo " -h" > ${WD}/boot.config

(cd ${CURDIR}/../../test/ppsapi && make)

cp ${CURDIR}/../../test/ppsapi/ppsapitest $WD/root

(
cd $WD/etc/rc.d

# NanoBSD routing
rm -f amd apm apmd atm* ccd dumpon gbde* ike ip6* ipfilter
rm -f ipsec ipxrouted isdnd jail kadmind kerberos kpasswdd lomac
rm -f lpd mixer motd mountd moused mroute6d mrouted network_ipv6
rm -f nfsd nfsserver nisdomain pccard pcvt pf pflog ppp-user pppoed
rm -f quota rarpd route6d routed rpcbind rtadvd rwho savecore sppp
rm -f syscons timed usbd vinum virecover yp*
rm -f bootparams ipfs ipmon ipnat

# NTPns specific
rm -f cron sendmail bgfsck

rm -f abi accuunting devd inetd keyserv named natd
rm -f nfsclient nfslocking othermta power_profile 

)

sed -i "" '/Root/s/.*/PermitRootLogin yes/' $WD/etc/ssh/sshd_config

(
cd $WD
tar zxvf ${CURDIR}/ntpns.tgz
)
