#!/usr/local/bin/perl5 -w
#
# $Id: kill_everywhere.pl,v 1.3 2006/11/04 14:40:48 ruben Exp $
#

#
# Script to stop all processes on all test boxes.
#

# Name of config file
$config_file = "/home/ttraffic/config/list_of_testboxes";
$ssh_command = "ssh -l ttraffic -i /ncc/ttpro/.ssh/ssh_ttraffic_key -x";


# Name of startup script on test-boxes
$start_command = "kill_processes.pl";

#
# Read list of test-boxes
#
open (TBOXES, $config_file) || die "Cannot open $config_file \n";
while (<TBOXES>) {
   if (substr($_, 0, 1) eq "#") { next; }

   chop ;
   ($host, $directory) = split (/\s+/, $_);

   print "\nConnecting to $host\n";

   # Check if the host is alive
   $alive = `ping -Q $host 64 5 2>&1`;

   if (index ($alive, "alive") > -1 ) {
     print "$host is alive and kicking\n";
     print "$directory\n";
     @result_list = `$ssh_command $host $directory/bin/$start_command`;
     for ($i=0 ; $i < $#result_list ; $i++) {
        print $result_list[$i];
     }
   } else {
     print "$host appears to be dead, skipped\n";
   }
   print "\n";

}


