#!/usr/local/bin/perl
#
# $Id: makefullmesh_ip6.pl,v 1.3 2006/11/04 14:40:49 ruben Exp $
#

#fill ttreg entries with full mesh a relation group
#command line:
#   makefullmesh.pl ttxx : makes full mesh only for ttxx
#   makefullmesh.pl      : makes full mesh for all online test boxes

use strict;

my $portnumber = "6000";
my $packetrate = "120";
my $packetlength = "100";
my $tracerouterate = "10";
my $addvaluedelay = "";
my $addvaluetrace = "";
my $target = "";
my $PATH = "/ncc/ttpro/bin/";
my $auxstr = $PATH."ttconfig -v IP6TTLIST CURRENT";
my @online = `$auxstr`;

@online = sort @online;
my @online2 = @online;

#parse command line
if($ARGV[0]){
    $target = $ARGV[0];
}

foreach my $tb (@online){
    my $aux = $tb;
    chop($aux);
    if($target){
	next if(!($aux=~/$target/));
	&create_addvalue($aux);       
        my $auxstr = $PATH."ttregconfig.pl ADD o6delay-t $aux $addvaluedelay";
        `$auxstr`;
        my $auxstr = $PATH."ttregconfig.pl ADD o6tracer-t $aux $addvaluetrace";
	`$auxstr`;
    }else{
	&create_addvalue($aux);
        my $auxstr = $PATH."ttregconfig.pl ADD o6delay-t $aux $addvaluedelay";
        `$auxstr`;
        my $auxstr = $PATH."ttregconfig.pl ADD o6tracer-t $aux $addvaluetrace";
	`$auxstr`;
    }
}

sub create_addvalue {

    $addvaluedelay = "";
    $addvaluetrace = "";
    my $tb = $_[0];
    foreach my $tb2 (@online2){
	my $aux2 = $tb2;
        chop($aux2);
	next if($tb=~/$aux2/);
	$addvaluedelay = $addvaluedelay ." ". '"'.$aux2." ".$portnumber." ".$packetrate." ".$packetlength.'"';
        $addvaluetrace = $addvaluetrace ." ". '"'.$aux2." ".$tracerouterate.'"';
    }

}
















