
/* Global constants */
/* ================ */
/* $Id: read_line.h,v 1.8 2007/02/06 11:49:50 ruben Exp $ */

/* Uncomment to switch on debugging output */
/* #define DEBUG     */
#define MAXWORDS 512
#define MAX_IP_SIZE 15

unsigned int rv_iptoint (const char *);
char* rv_inttoip (unsigned int, char *);

int read_line (char *buf, unsigned int *src, unsigned int *dest, int* timestamp,
		int *npoints, char *ipvec, char *aspath, GHashTable* asnums);

int read_line_ip6 (char *buf, char **src, char **dest, int* timestamp,
		int *npoints, char *ipvec, char *aspath, GHashTable* asnums);


const char *match_ip_as (GHashTable* asnums, const char *ipstring, int ip6flag);
/* returns ASnum(s) for specified IP address (ascii format) */

