
/* $Id: merge_packets.h,v 1.4 2007/02/06 12:15:07 ruben Exp $ */

/* TRUE and FALSE */
#ifndef TRUE
#   define TRUE (1)
#   define FALSE (0)
#endif

extern struct packet *list_of_packets[MAXPACKETS];
extern struct packet *list_of_packets6[MAXPACKETS];

extern int      number_of_packets;
extern int      number_of_packets6;

int             read_received_packets(char *, int);
int             read_existing_packets(const char *, const char *, int, int, int);
FILE           *open_packet_file(int, const char *, const char *, int, int);
int             write_packet_data(FILE *, struct packet *);
int             close_new_packet_file(FILE *);
int             read_new_packets(const char *, const char *, int, int);
void            print_packet(struct packet *);
int             search_packet(unsigned int pcktid, int srcid, int trgid, int numpackets);
int             search_packet6(unsigned int pcktid, int srcid, int trgid, int numpackets);
void            sort_packets(int debug);
FILE           *openfile(const char *, const char *, int *);
int             compare_packet(const void *a, const void *b);
