#!/usr/local/bin/perl5
#
# $Id: map_index_alternate.cgi,v 1.2 2006/11/04 14:49:59 ruben Exp $
#

use CGI qw/:standard/;   # Load CGI module

#---------------------------------------------------------------
#  INPUTS TO THE SCRIPT
#---------------------------------------------------------------

my $map      = param('map');       # which map to display
my $src      = param('src');       # source testbox
my $dst      = param('dst');       # destination testbox
my $var      = param('var');       # variable in which to store requested testbox
my $url      = param('url');       # url (minus query) of the calling script
my $redirect = param('redirect');  # url to redirect user to (eventually)

do 'maps.locations';

#----------------------------------------------------------------
#  Parse map file, get only relevent information for this map
#----------------------------------------------------------------

do "$CGIpre/$CGIdir/map_import.pl";
my $htmlstring = &import_maps($url . "?src=$src&dst=$dst", $var, $redirect);

# get appropriate imagemap into $1
$htmlstring =~ /(<map name='map_$map'>.+?)<script.+?>.+?<\/script>(.+?<\/map>)/s;
my $imagemap = $1 . $2; 

#----------------------------------------------------------------
#  Get style info for the page, but not RIPE images
#----------------------------------------------------------------

my $styles = `cat $SSIpre/$SSIdir/ttmhead1.inc`;

$styles =~ s/(\<body.+?\>).+\Z/$1/s;

#----------------------------------------------------------------
#  Create page
#----------------------------------------------------------------

print 
    header,
    "<html>\n<head>\n",
    title("Map of $map: select a testbox"), "\n",
    $styles, "\n\n",
    h1("Select a testbox in this region:");

print <<"ENDJS";

<script langauge='JavaScript' src='$WWWdir/$JAVAFUNCS'></script>

<form name="displayform">
  <input type="textbox" name="displaybox" size=100>
</form>
$imagemap
<img src='$WWWdir/maps.${map}.gif' usemap='#map_$map' border=0>
ENDJS

print end_html;






