#!/usr/local/bin/perl5
#
# $Id: map_index_cluster.cgi,v 1.2 2006/11/04 14:49:59 ruben Exp $
#

use CGI qw/:standard/;   # Load CGI module

#---------------------------------------------------------------
#  INPUTS TO THE SCRIPT
#---------------------------------------------------------------

my $map      = param('map');       # which map to display
my $src      = param('src');       # source testbox
my $dst      = param('dst');       # destination testbox
my $var      = param('var');       # variable in which to store requested testbox
my $url      = param('url');       # url (minus query) of the calling script
my $redirect = param('redirect');  # url to redirect user to (eventually)

do 'maps.locations';

#----------------------------------------------------------------
#  Parse map file, get only relevent information for this map
#----------------------------------------------------------------

do "$CGIpre/$CGIdir/map_import.pl";
my $htmlstring = &import_maps($url . "?src=$src&dst=$dst", $var, $redirect);

# get appropriate layer into $1
$htmlstring =~ /(<div id=\"$map\"(.+?)<\/div>)/s;
my $layer = $1;

# capture testbox location information only
$layer =~ s{(<a href.+?)onMouseOver.+?display\('(.+?)'\).+?(onClick.+?>).+?</a>}
	   {${1}${3}${2}</a>}g;

# get rid of layer information
$layer =~ s/<div.+?>\n//;
$layer =~ s/<\/div>//;

# format layer
$layer = "<h3 style='line-height:1.25'>\n" . $layer . "</h3>";

#----------------------------------------------------------------
#  Get style info for the page, but not RIPE images
#----------------------------------------------------------------

my $styles = `cat $SSIpre/$SSIdir/ttmhead1.inc`;

$styles =~ s/(\<body.+?\>).+\Z/$1/s;

#----------------------------------------------------------------
#  Create page
#----------------------------------------------------------------

print 
    header,
    html,
    title("Select a testbox"), "\n",
    $styles, "\n\n",
    h1("Select a testbox at this location:"),
    "<script langauge='JavaScript' src='$WWWdir/$JAVAFUNCS'></script>\n",
    $layer,
    end_html;




