#!/usr/local/bin/perl5
#
# $Id: color_convert.pl,v 1.2 2006/11/04 14:49:59 ruben Exp $
#

sub color_dec2hex {
    my $input = shift;
    $input =~ s[(-[A-Z])(\d{3})/(\d{3})/(\d{3})\b]
	       [sprintf ("#%02x%02x%02x", $2, $3, $4)]ge;
    return $input;
}
sub color_hex2dec {
    my $input = shift;
    my $chars = "A-Fa-f0-9";
    $input =~ s[\#([$chars]{2})([$chars]{2})([$chars]{2})\b]
	       [sprintf ("%03d/%03d/%03d", hex($1), hex($2), hex($3))]ge;
    return $input;
}
