#!/usr/local/bin/perl5
#
# $Id: test.pl,v 1.2 2006/11/04 14:49:59 ruben Exp $
#

do "color_convert.pl";

my $color;
if (@ARGV) {
    $color = shift @ARGV;
} else {
    die
	"Please specify an argument in #rrggbb or rrr/ggg/bbb format\n",
	"where rrggbb is in hexidecimal \n",
	"and rrr,ggg,bbb are in decimal, no larger than 255\n";
}

my $dec = color_hex2dec ($color);
my $hex = color_dec2hex ($color);

print $dec, "\n" if $dec ne $color;
print $hex, "\n" if $hex ne $color;
print "Could not convert $color\n" if ($hex eq $color and $dec eq $color);

