#!/usr/local/bin/perl5
#
# $Id: tt_routing.pl,v 1.2 2000/09/01 14:11:18 ttraffic Exp $
#
# Copyright (c) 2000  RIPE NCC
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appear in all copies and that
# both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of the author not be
# used in advertising or publicity pertaining to distribution of the
# software without specific, written prior permission.
#
# THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
# AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
# DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
# AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
#------------------------------------------------------------------------------
# Module Header
# Filename          :   tt_routing.pl
# Purpose           :   Automated generation of TTM webpages in html
# Authors           :   Fotis Georgatos <fotis@ripe.net>, RIPE NCC
# Date              :   18-AUG-2000
# Description       :   Component of TTwwwpages for Test Traffic project
# Input             :   derived from "ttconfig" script  
# Output            :   html code in stdout
# Language Version  :   perl
#------------------------------------------------------------------------------

$TTROOT="/ncc/ttpro";

open( INFO, "$TTROOT/bin/ttconfig -v TTLIST |") || die "Cannot get list of testboxes\n";
@TTLIST = <INFO>;
close(INFO); 

foreach $ff (@TTLIST)
{
  $f=$ff;
  chop $f;
  print "  <option value=\"$f\">$f</option>\n";
}
