/*
 * Copyright (c) 2002,2003 Endace Technology Ltd, Hamilton, New Zealand.
 * All rights reserved.
 *
 * This source code is proprietary to Endace Technology Limited and no part
 * of it may be redistributed, published or disclosed except as outlined in
 * the written contract supplied with this product.
 *
 * $Id: helper.h,v 1.1.1.1 2005/04/05 12:11:52 tom Exp $
 */

/*
 *
 * Prototypes for stdio error and message display
 *
 * AKA Helper routines
 *
 */

extern char	usgtxt[];
extern void	set_progname(char *argv0);
extern char	*get_progname(void);
extern void	set_signal_handler(void (*handler)(int));
extern void	set_verbosity(int v);
extern int	get_verbosity(void);
#define inc_verbosity() set_verbosity(get_verbosity()+1)
#define dec_verbosity() set_verbosity(get_verbosity()-1)
extern void	panic(char *fmt, ...)	__attribute__((noreturn, format (printf, 1, 2)));
extern void	error(char *fmt, ...)	__attribute__((format (printf, 1, 2)));
extern void    	warning(char *fmt, ...) __attribute__((format (printf, 1, 2)));
extern void	verbose(char *fmt, ...)	__attribute__((unused, format (printf, 1, 2)));
extern void	message(char *fmt, ...)	__attribute__((unused, format (printf, 1, 2)));
extern void	usage(void)		__attribute__((noreturn));;


