{

#include <stdlib.h>

TH2D *h1 = new TH2D ("h1", "", 20, 0.0, 21.0, 100, 0.0, 12.0);

h1->SetXTitle("Measurement");
h1->SetYTitle("Bandwidth (Mbit/s)");

c1 = new TCanvas("c1","",0,10,870,630);

c1->SetFillColor(0);
c1->SetGrid();
c1->GetFrame()->SetFillColor(21);
c1->GetFrame()->SetBorderSize(0);

Int_t n=20;

Float_t  x[n];
Float_t ex[n];
Float_t  y[n];
Float_t ey[n];
Int_t i;

for (i=0 ; i<n ; i++) {
  x[i] = i+1;
  y[i] = (float) rand()/ (float) RAND_MAX;
  y[i] = y[i] - 0.5 ;
  y[i] = y[i]/20.0;
  y[i] = 9.6 * (1 + y[i]) ;
  printf ("%f\n", y[i]);
  ex[i] = 0.0;
  ey[i] = 0.0;
}

h1->Draw();

   gr = new TGraphErrors(n,x,y,ex,ey);
   gr->SetMinimum(0.0);
   gr->SetMaximum(2200.0);
   gr->SetTitle("RS tickets");
   gr->SetMarkerColor(4);
   gr->SetMarkerStyle(21);
   gr->Draw("P+");

   c1->Update();


}

