#!/usr/bin/perl

use POSIX;
use IO::Socket;
use CGI qw(:standard);

# Our CGI query object
$query = new CGI;

# Open connection to server and send "list" command
my $socket = new IO::Socket::INET(
   Proto  => 'tcp',
   PeerAddr  => 'rimu.ripe.net',
   PeerPort  => '4260'
);
#die "can't setup socket: $!" unless $socket;
$socket->autoflush(1);

# Request the image that
print $socket "image\n";
print $socket $query->param('filename')."\n";
print $socket "end\n";

# Print out the image that we recieve over the socket
print $query->header( -type       => "image/png",
                      -attachment => "$query->param(\"filename\")" );

# Output the image we got over the socket
while (<$socket>) {
   print $_;
}
