#
# $Id: avpos.pl,v 1.2 2006/11/04 15:28:54 ruben Exp $
#

# DLLA: 52:22.36954 N;   4:53.28604 E;      21.87         0.00 Tue 15:11:17.00   

$w = 1;


sub hweight {
	($dop) = @_;
	return(6-$dop);
}

sub vweight {
	($dop) = @_;
	return(8-$dop);
}

while (<>) {
	
	if ($_=~/^Mode:.*DOPs:/) {
		s/^.*DOPs: //;
		($dummy,$dummy,$dummy,$hdop,,$dummy,$vdop) = split(/\s+/);
	}
	elsif ($_=~/^DLLA/) {
		@parts = split(/[ :]+/);
		$dlat = @parts[1];
		$mlat = @parts[2];
		$dlon = @parts[4];
		$mlon = @parts[5];
		$alt = @parts[7];

		$adlat += $dlat;
		$amlat += $mlat;
		$adlon += $dlon;
		$amlon += $mlon;
		$aalt += $alt;

		$wdlat += $dlat*hweight($hdop);
		$wmlat += $mlat*hweight($hdop); 
		$wdlon += $dlon*hweight($hdop);
		$wmlon += $mlon*hweight($hdop); 
		$walt += $alt * vweight($vdop);

		$n ++;
		$hn += hweight($hdop);
		$vn += vweight($vdop);

#		print "$dlat:$mlat $dlon:$mlon $alt $hdop $vdop\n";
	}
}

$vweight = $vn/$n;
$hweight = $hn/$n;

printf "n=$n  v=$vweight $h=$hweight\n";
printf "Plain    %d:%f %f:%f %f\n", 
	$adlat/$n, $amlat/$n, $adlon/$n, $amlon/$n, $aalt/$n;

printf "Weighted %d:%f %f:%f %f\n", 
	$wdlat/$hn, $wmlat/$hn, $wdlon/$hn, $wmlon/$hn, $walt/$vn;
